;//-----------------------------LICENSE NOTICE------------------------------------
;//  This file is part of Project AcReturns
;//  Copyright (C) 2018 AcReturns
;//
;//  This program is free software: you can redistribute it and/or modify
;//  it under the terms of the GNU General Public License as published by
;//  the Free Software Foundation, either version 3 of the License, or
;//  (at your option) any later version.
;//
;//  This program is distributed in the hope that it will be useful,
;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;//  GNU General Public License for more details.
;//
;//  You should have received a copy of the GNU General Public License
;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;//-------------------------------------------------------------------------------

.include "entity.h.s"
.include "collisionEnemy.h.s"
.include "collision.h.s"
.include "map.h.s"

.globl _song_indead

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SEE IF THE COLLISION WAS WITH AN ENEMY
;; DESTROYED REGISTERS: A
;; INPUT: IX -> POINTER TO THE ENTETY (hero)
;; RETURN: A == 1 IF WAS AN ENEMY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 1100 0000 -> enemy
checkCollision_enemy::
  call collision_tester
  or a
  jr nz, collision

  ld a,#0
  ret
  
  collision:
	ld a, e_ch(ix)                    ;; Comprobamos si es un objeto animado
  bit #7,a
  jr nz,animated
        ld a,#0                           ;; Si no lo es devolvemos 0
        ret
  
  animated:
  push de
  ld    de, #_song_indead 
  call cpct_akp_musicInit_asm
  call cpct_akp_musicPlay_asm
  pop de

  call dead_hero
  ld a,#1                           ;; If is an enemy, return 1
  ret
