;//-----------------------------LICENSE NOTICE------------------------------------
;//  This file is part of Project AcReturns
;//  Copyright (C) 2018 AcReturns
;//
;//  This program is free software: you can redistribute it and/or modify
;//  it under the terms of the GNU General Public License as published by
;//  the Free Software Foundation, either version 3 of the License, or
;//  (at your option) any later version.
;//
;//  This program is distributed in the hope that it will be useful,
;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;//  GNU General Public License for more details.
;//
;//  You should have received a copy of the GNU General Public License
;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;//-------------------------------------------------------------------------------

.include  "cpctelera.h.s"
;.include   "render.h.s"
.include  "counters.h.s"
.include  "menu.h.s"

.include "entity.h.s"

.globl level
.globl negative_size_digit
;;  Counters

;; Constats for counters
min_timer_max: .db #02; minutos +1
sec_timer_max: .db #61; minutos +1 combrobar y actualizar
sec_vsync_max: .db #05; minutos +1; 109
times_vsync_max:  .db #06; minutos +1


;; Timer Counters
min_timer: .db #00; minutos +1
sec_timer: .db #00; minutos +1
sec_vsync: .db #00; minutos +1; 250
times_vsync:  .db #00; minutos +1

DefineDrawableEntity timer_first_digit_data, 0x40, 0x40, 0x40, 0x8C, 0x8C, 0x8C, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity timer_second_digit_data, 0x44, 0x44, 0x44, 0x8C, 0x8C, 0x8C, 0x04, 0x08 , _numeros_sp_09

DefineDrawableEntity timer_third_digit_data, 0x48, 0x48, 0x48, 0x8C, 0x8C, 0x8C, 0x04, 0x08 , _numeros_sp_00



DefineDrawableEntity dead_first_digit_data, 0x1A, 0x1A, 0x1A, 0xB4, 0xB4, 0xB4, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity dead_second_digit_data, 0x1E, 0x1E, 0x1E, 0xB4, 0xB4, 0xB4, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity dead_third_digit_data, 0x22, 0x22, 0x22, 0xB4, 0xB4, 0xB4, 0x04, 0x08 , _numeros_sp_00



DefineDrawableEntity score_first_digit_data, 0x1A, 0x1A, 0x1A, 0x8C, 0x8C, 0x8C, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity score_second_digit_data, 0x1E, 0x1E, 0x1E, 0x8C, 0x8C, 0x8C, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity score_third_digit_data, 0x22, 0x22, 0x22, 0x8C, 0x8C, 0x8C, 0x04, 0x08 , _numeros_sp_00


size_digit: .dw 0x0020
negative_size_digit: .dw 0xFFE0

size_of_next_digit: .dw 0x000A 


;; inputs
;;  
.macro check_is_number name, number, register

  ld    l, de_sp_l(register)                         ;; A = First 2 digits of the counter
  ld    h, de_sp_h(register) 
  ld    bc, number
  ld    a, c
  cp    l                        ;; A - 0x39, (9 in asciz)
  jr    z, continue_check_digit'name        

    ;;no is number
    jr    no_is_number'name
       
        
  continue_check_digit'name:
    ld    a, b
    cp    h
    jr    z, is_the_number'name

      ;;no is number
      no_is_number'name:
        ;;we can continue substract
        ld    a, #0
        jr    end_check_is_number'name

    is_the_number'name:
      ;;we cant continue substract
      ld    a, #1
      

    end_check_is_number'name:

.endm


;;  


   

.macro add_carry_to_score name

  continue_add_carry_to_score'name:
    ld    a, (carry_to_third_digit)
    dec   a
    jp    m, end_add_carry_to_score'name

      ;inc   bc
      ;; ix == second_score
      check_is_number name, #_numeros_sp_09, ix
      or    a
      jr    z, add_without_carry'name

        ;; set score_second_digit to 0
        ld    hl, #_numeros_sp_00
        ld    de_sp_l(ix), l
        ld    de_sp_h(ix), h

        ;; inc 1 score_third_digit, then inc carry_to_second_digit
        ld    a, (carry_to_second_digit)
        inc   a
        ld    (carry_to_second_digit), a

        ld    a, (carry_to_third_digit)
        dec   a
        ld    (carry_to_third_digit), a

        jr    continue_add_carry_to_score'name

      add_without_carry'name:

        ;; dec 1 carry_to_third_digit
        ld    a, (carry_to_third_digit)
        dec   a
        ld    (carry_to_third_digit), a

        ;;inc  1 score
        increments_digit name, size_digit, ix

        jr    continue_add_carry_to_score'name


    end_add_carry_to_score'name:
    ;; restore carry_to_third_digit to 0
      ld    a, (carry_to_third_digit)
      inc   a
      ld    (carry_to_third_digit), a


.endm   




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INICIALIZE COUNTERS 
;; DESTROYED REGISTERS:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
inicialize_counters:
                ;; Carga los puntos de la muerte
  
  push  ix 

  ld    ix, #timer_first_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #timer_second_digit_data
  ld    hl, #_numeros_sp_09
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h
  
  ld    ix, #timer_third_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #dead_first_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #dead_second_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #dead_third_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #score_first_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #score_second_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #score_third_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h


  pop   ix
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LOAD POINTS
;; INPUT IY -> Contador muertes o points
;; DESTROYED REGISTERS:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_points:
 
  push  ix

  ld    ix, #timer_first_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #timer_second_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #timer_third_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #dead_first_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #dead_second_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #dead_third_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #score_first_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #score_second_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #score_third_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  pop   ix
  ret





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ADD the timer of the score
;; DESTROYED REGISTERS:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
more_points:

  push  ix
  push  iy

  continue_more_points:

  ld    ix, #score_third_digit_data
  ld    iy, #timer_third_digit_data

  
  check_is_number name1, #_numeros_sp_00, iy
  or    a
  jp    z, continue_add_score

    ;;timer3 == 0
    ld    iy, #timer_second_digit_data
    check_is_number name2, #_numeros_sp_00, iy
    or    a
    jr    z, continue_add_score2

      ;;timer2 == 0, go to end
      jp    end_more_points

    ;; timer2 != 0  
    continue_add_score2:

      ;; dec 1 timer2
      ld    iy, #timer_second_digit_data
      ld    l, de_sp_l(iy)
      ld    h, de_sp_h(iy)
      increments_digit name3, negative_size_digit, iy

      ;; set timer_third to 9
      ld    iy, #timer_third_digit_data
      ld    hl, #_numeros_sp_09
      ld    de_sp_l(iy), l
      ld    de_sp_h(iy), h

      check_is_number name4, #_numeros_sp_09, ix
      or    a
      jp    z, add_without_carry2

        ;;score3 == 9
        ld    ix, #score_second_digit_data
        check_is_number name5, #_numeros_sp_09, ix
        or    a
        jr    z, add_without_carry3

          ;;score2 == 9

          ;;set score2 = 0
          ld    hl, #_numeros_sp_00
          ld    de_sp_l(ix), l
          ld    de_sp_h(ix), h

          ;;set score3 = 0
          ld    ix, #score_third_digit_data
          ld    hl, #_numeros_sp_00
          ld    de_sp_l(ix), l
          ld    de_sp_h(ix), h

          
          ld    ix, #score_first_digit_data
          check_is_number name50, #_numeros_sp_09, ix
          or    a
          jr    z, add_without_carry9

            ;; score1 == 9
            jp    continue_more_points

          ;; score1 != 9 
          add_without_carry9:
            ;; inc score1
            ld    ix, #score_first_digit_data
            ld    l, de_sp_l(ix)
            ld    h, de_sp_h(ix)
            increments_digit name6, size_digit, ix

            jp    continue_more_points

        ;; score2 != 9  
        add_without_carry3:

          ;;inc 1 score2 
          ld    ix, #score_second_digit_data
          ld    l, de_sp_l(ix)
          ld    h, de_sp_h(ix)
          increments_digit name7, size_digit, ix

          ;;set score3 = 0
          ld    ix, #score_third_digit_data
          ld    hl, #_numeros_sp_00
          ld    de_sp_l(ix), l
          ld    de_sp_h(ix), h
          
          jp    continue_more_points


      ;;score3 != 9
      add_without_carry2:
        ;;inc 1 score3
        ld    ix, #score_third_digit_data
        ld    l, de_sp_l(ix)
        ld    h, de_sp_h(ix)
        increments_digit name8, size_digit, ix

        jp    continue_more_points
      
  ;; timer3 != 0
  continue_add_score:

    check_is_number name9, #_numeros_sp_09, ix
    or    a
    jp    z, add_without_carry4

      ;;score3 == 9
      ld    ix, #score_second_digit_data
      check_is_number name10, #_numeros_sp_09, ix
      or    a
      jr    z, add_without_carry5

        ;;score2 == 9

        ;;set score2 = 0
        ld    hl, #_numeros_sp_00
        ld    de_sp_l(ix), l
        ld    de_sp_h(ix), h

        ;;set score3 = 0
        ld    ix, #score_third_digit_data
        ld    hl, #_numeros_sp_00
        ld    de_sp_l(ix), l
        ld    de_sp_h(ix), h

        
        ld    ix, #score_first_digit_data
        check_is_number name51, #_numeros_sp_09, ix
        or    a
        jr    z, add_without_carry10

          ;; score1 == 9
          jp    dec_timer3

        ;; score1 != 9 
        add_without_carry10:
          ;; inc score1
          ld    ix, #score_first_digit_data
          ld    l, de_sp_l(ix)
          ld    h, de_sp_h(ix)
          increments_digit name6, size_digit, ix

          jp    dec_timer3


        ld    ix, #score_first_digit_data
        ld    l, de_sp_l(ix)
        ld    h, de_sp_h(ix)
        increments_digit name11, size_digit, ix

        jr    dec_timer3

      ;; score2 != 9  
      add_without_carry5:

        ;;inc 1 score2 
        ld    ix, #score_second_digit_data
        ld    l, de_sp_l(ix)
        ld    h, de_sp_h(ix)
        increments_digit name12, size_digit, ix

        ;;set score3 = 0
        ld    ix, #score_third_digit_data
        ld    hl, #_numeros_sp_00
        ld    de_sp_l(ix), l
        ld    de_sp_h(ix), h
        
        jr    dec_timer3


    ;;score3 != 9
    add_without_carry4:
      ;;inc 1 score3
      ld    ix, #score_third_digit_data
      ld    l, de_sp_l(ix)
      ld    h, de_sp_h(ix)
      increments_digit name13, size_digit, ix

      
      dec_timer3:
        ;; dec 1 timer3
        ld    iy, #timer_third_digit_data
        ld    l, de_sp_l(iy)
        ld    h, de_sp_h(iy)
        increments_digit name14, negative_size_digit, iy

      jp    continue_more_points
      
  end_more_points:

    pop   iy
    pop   ix 
    call  load_points


  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TIMER  
;; DESTROYED REGISTERS:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
timer:

  ld    a, (times_vsync_max)        ;; A = times_vsync_max, number of calls of vsycns
  ld    d, a                        ;; D = A
  ld    a, (times_vsync)            ;; A = counter of times_vsync
  inc   a                           ;; A = A + 1
  ld    (times_vsync), a            ;; update counter of times_vsync
  cp    d                           ;; A - D
  ret   nz                          ;; if (A - D != 0) then exit function
  
  ;; not jump (A - D == 0)
  ld    a, #00                      ;; |
  ld    (times_vsync), a            ;; \ restore counter of times_vsync

  ;;times_vsync == 0
  ld    a, (sec_vsync_max)          ;; A = sec_vsync_max, number of calls of sec_vsync
  ld    d, a                        ;; D = A
  ld    a, (sec_vsync)              ;; A = counter of sec_vsync
  inc   a                           ;; A = A + 1
  ld    (sec_vsync), a              ;; update counter of sec_vsync
  cp    d                           ;; A - D
  ret   nz                          ;; if (A - D != 0) then exit function

  ;; not jump (A - D == 0)
  ld    a, #00                      ;; |
  ld    (sec_vsync), a              ;; \ restore counter of sec_vsync

  ;; sec_vsync == 0



  ;;draw a number
  push    ix

  ld    ix, #timer_third_digit_data
  check_is_number name15, #_numeros_sp_00, ix
  or    a
  jr    z, continue_dec_timer

    ;; check second_digit timer
    ld    ix, #timer_second_digit_data
    check_is_number name16, #_numeros_sp_00, ix
    or    a
    jr    z, continue_dec_second_timer

      ;;finish the time nos manda al nivel anterior
      call  load_points
      ld    a,  (level)
      cp    #1
      jr    z , no_modifico
            ;; Level != 1
            ld    a,  #2
            ld    c,  a
            ld    a,  (level)
            sub   c
            ld    (level), a
            ld    a,  #99
            jr continue

      no_modifico:
      ;; Level = 0
      dec a
      ld  (level), a
      call load_second_digit
      increments_digit name67, negative_size_digit, ix      ;; Decrementamos porque el loadScreen incrementa

      continue:
      call  load_endScreen

      pop   ix
      ret

    continue_dec_second_timer:

      ;; dec 1 timer_second_digit
      increments_digit name17, negative_size_digit, ix

      ;; set timer_third_digit to 9
      ld    ix, #timer_third_digit_data
      ld    hl, #_numeros_sp_09
      ld    de_sp_l(ix), l
      ld    de_sp_h(ix), h

      jr    update_timer_in_screen
    
  continue_dec_timer:

    increments_digit name18, negative_size_digit, ix


  update_timer_in_screen:
    call load_points
  

  pop ix
      ;call  draw_string



  ld    a, (sec_timer_max)          ;; A = sec_timer_max, number of calls of sec_timer
  ld    d, a                        ;; D = A
  ld    a, (sec_timer)              ;; A = counter of sec_timer
  inc   a                           ;; A = A + 1
  ld    (sec_timer), a              ;; update counter of sec_timer
  cp    d                           ;; A - D
  ret   nz                          ;; if (A - D != 0) then exit function

  ;; not jump (A - D == 0)
  ld    a, #00                      ;; |
  ld    (sec_timer), a              ;; \ restore counter of sec_timer
  ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TIMER  
;; DESTROYED REGISTERS:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
counter_number_of_deads::
  ;name15

  push  ix
  push  iy

  ld    ix, #score_third_digit_data
  ld    iy, #dead_third_digit_data

  
  check_is_number name19, #_numeros_sp_09, iy
  or    a
  jp    z, continue_add_deads

    ;;deads3 == 9
    ld    iy, #dead_second_digit_data
    check_is_number name20, #_numeros_sp_09, iy
    or    a
    jr    z, continue_add_deads2

      ;;deads2 == 9,

      ;; set 0 deads2
      ld    hl, #_numeros_sp_00
      ld    de_sp_l(iy), l
      ld    de_sp_h(iy), h

      ;; set 0 deads3
      ld    iy, #dead_third_digit_data
      ld    hl, #_numeros_sp_00
      ld    de_sp_l(iy), l
      ld    de_sp_h(iy), h

      ;; inc 1 deads1 
      ld    iy, #dead_first_digit_data
      ld    l, de_sp_l(iy)
      ld    h, de_sp_h(iy)
      increments_digit name21, size_digit, iy

      jp    dec_score

      

    ;; deads2 != 9 
    continue_add_deads2:

      ;; inc 1 deads2
      ld    iy, #dead_second_digit_data
      ld    l, de_sp_l(iy)
      ld    h, de_sp_h(iy)
      increments_digit name22, size_digit, iy

      ;; set deads3 to 0
      ld    iy, #dead_third_digit_data
      ld    hl, #_numeros_sp_00
      ld    de_sp_l(iy), l
      ld    de_sp_h(iy), h

      jp    dec_score

      
    
      
  ;; deads3 != 9
  continue_add_deads:

    ;; inc 1 deads3
    ld    iy, #dead_third_digit_data
    ld    l, de_sp_l(iy)
    ld    h, de_sp_h(iy)
    increments_digit name23, size_digit, iy

    dec_score:

      check_is_number name24, #_numeros_sp_00, ix
      or    a
      jp    z, continue_dec_score

        ;;score3 == 0
        ld    ix, #score_second_digit_data
        check_is_number name25, #_numeros_sp_00, ix
        or    a
        jp    z, continue_dec_score2

          ;;score2 == 0
          ld    ix, #score_first_digit_data
          check_is_number name26, #_numeros_sp_00, ix
          or    a
          jp    z, continue_dec_score3

            ;; score1 == 0
            jp    end_counter_number_of_deads

          ;; score 1 != 0
          continue_dec_score3:
            ;; dec score1
            ld    ix, #score_first_digit_data
            ld    l, de_sp_l(ix)
            ld    h, de_sp_h(ix)
            increments_digit name27, negative_size_digit, ix

            ;; set score2 = 9
            ld    iy, #score_second_digit_data
            ld    hl, #_numeros_sp_09
            ld    de_sp_l(iy), l
            ld    de_sp_h(iy), h

            ;; set score3 = 9
            ld    iy, #score_third_digit_data
            ld    hl, #_numeros_sp_09
            ld    de_sp_l(iy), l
            ld    de_sp_h(iy), h

            jp    end_counter_number_of_deads

        ;; score2 != 0
        continue_dec_score2:
          ;; dec score2
          ld    ix, #score_second_digit_data
          ld    l, de_sp_l(ix)
          ld    h, de_sp_h(ix)
          increments_digit name28, negative_size_digit, ix

          ;; set score3 = 9
          ld    iy, #score_third_digit_data
          ld    hl, #_numeros_sp_09
          ld    de_sp_l(iy), l
          ld    de_sp_h(iy), h

          jp    end_counter_number_of_deads

      ;; score3 != 0    
      continue_dec_score:
        ;; dec score3
        ld    ix, #score_third_digit_data
        ld    l, de_sp_l(ix)
        ld    h, de_sp_h(ix)
        increments_digit name29, negative_size_digit, ix

    
  end_counter_number_of_deads:

    pop   iy
    pop   ix 
    call  load_points


  ret




  ;;;
  ;;;;;;;;;;,
  ;;;;;;;

restart_timer::
  push  ix

  ld    ix, #timer_first_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  ld    ix, #timer_second_digit_data
  ld    hl, #_numeros_sp_09
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h
  
  ld    ix, #timer_third_digit_data
  ld    hl, #_numeros_sp_00
  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h

  pop   ix

  ret
