;//-----------------------------LICENSE NOTICE------------------------------------
;//  This file is part of Project AcReturns
;//  Copyright (C) 2018 AcReturns
;//
;//  This program is free software: you can redistribute it and/or modify
;//  it under the terms of the GNU General Public License as published by
;//  the Free Software Foundation, either version 3 of the License, or
;//  (at your option) any later version.
;//
;//  This program is distributed in the hope that it will be useful,
;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;//  GNU General Public License for more details.
;//
;//  You should have received a copy of the GNU General Public License
;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;//-------------------------------------------------------------------------------

.include  "render.h.s"
;###########################################################################
;#### FICHERO: entity.h.s
;###########################################################################

.macro DefineObsEntity _name, _x0, _x1, _x2, _y0, _y1, _y2, _w, _h, _sprite
_name:
  DefineDrawableEntity _name'_dw, _x0, _x1, _x2, _y0, _y1, _y2, _w, _h, _sprite
.endm

.macro DefineObjEntity _name, _x0, _x1, _x2, _y0, _y1, _y2, _w, _h, _sprite, _characteristics
_name:
  DefineDrawableEntity _name'_dw, _x0, _x1, _x2, _y0, _y1, _y2, _w, _h, _sprite
  .db  _characteristics
.endm

.macro DefineEntity _name, _x0, _x1, _x2, _y0, _y1, _y2, _w, _h, _sprite,_type,_vx, _vy, _upd
_name:
   DefineDrawableEntity _name'_dw, _x0, _x1, _x2, _y0, _y1, _y2, _w, _h, _sprite
   .db  _type
   .db   _vx, _vy     ;; VX, VY
   .dw   _upd        ;; Update
  _name'_size =   .  - _name
.endm

.macro DefineEntityDefault _name, _suf
   DefineEntity _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFFFF
.endm

.macro DefineNEntities _name, _n
  _c = 0
  .rept _n
     DefineEntityDefault _name, \_c
     _c = _c + 1
  .endm
.endm

;;  Struct for the Obstacles
.macro DefineEntityObsDefault _name, _suf
   DefineObsEntity _name'_suf, 0, 0, 0, 0, 0
.endm

.macro DefineNObsEntities _name, _n
  _c = 0
  .rept _n
     DefineEntityObsDefault _name, \_c
     _c = _c + 1
  .endm
.endm

e_de      = 0  
e_de_size = 10
e_ch      = 0  + e_de_size
e_vx      = 1  + e_de_size
e_vy      = 2  + e_de_size
e_up_l    = 3  + e_de_size
e_up_h    = 4  + e_de_size

 
.globl	ent_draw
.globl  ent_move
.globl	ent_clear
.globl	ent_update
.globl  ent_copy
.globl  ent_new
.globl  vector_clean
.globl  ent_doForAll
.globl  ent_doForAllY
.globl	hero_data
.globl	enemy_data
.globl  enemy_data1
.globl  enemy_data2
.globl  enemy_data3
.globl  enemy_data4
.globl  enemy_data5
.globl  enemy_data6
.globl  enemy_data7
;.globl	obs_data
.globl	entity_vector
.globl	m_next_entity
.globl  key_data
.globl  dead_hero
.globl restauro
.globl e_ch

key_l       = 0
key_h       = 1

sprite_l    = 4
sprite_h    = 5