;//-----------------------------LICENSE NOTICE------------------------------------
;//  This file is part of Project AcReturns
;//  Copyright (C) 2018 AcReturns
;//
;//  This program is free software: you can redistribute it and/or modify
;//  it under the terms of the GNU General Public License as published by
;//  the Free Software Foundation, either version 3 of the License, or
;//  (at your option) any later version.
;//
;//  This program is distributed in the hope that it will be useful,
;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;//  GNU General Public License for more details.
;//
;//  You should have received a copy of the GNU General Public License
;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;//-------------------------------------------------------------------------------

;###########################################################################
;#### FICHERO: entity.s
;###########################################################################
.include "cpctelera.h.s"
.include "entity.h.s"
.include "keyboard/keyboard.h.s"
.include "collision.h.s"
.include "ialogic.h.s"
.include "menu.h.s"
.include "collisionEnemy.h.s"
.include "map.h.s"
.include "counters.h.s"

;;  Sprite Wall
;.globl _muro_sp

;;  Sprite Key
;.globl _key_sp

;;  Sprites Hero
;.globl _hero_sp_0                   ;;  Position  Down    
;.globl _hero_sp_1                   ;;  Position  Up
;.globl _hero_sp_2                   ;;  Position  Right
;.globl _hero_sp_3                   ;;  Position  Left

;;  Sprites Enemy
;.globl _definity_enemy_sp_00        ;;  Position  Left
;.globl _definity_enemy_sp_01        ;;  Position  Down
;.globl _definity_enemy_sp_02        ;;  Position  Right
;.globl _definity_enemy_sp_03        ;;  Position  Up

;;===============================================================
;;===============================================================
;; PRIVATE DATA
;;===============================================================
;;===============================================================
;entity_obs_vector:
;DefineObsEntity obs_data, 0x4A, 0x4A, 0x4A, 0x20, 0x20, 0x20, 0x02, 0x08, _muro_sp

;  Constants moves
left  = -1
right = 1
up    = -2
down  = 2
idle  = 0

  ;; Axis of movement  0 = X, 1 = Y

axis:: .db 0x0


;; esta en el entity.h.s
;key_l       = 0
;key_h       = 1
direction_x = 2  
direction_y = 3
sprite_l    = 4
sprite_h    = 5

option_size: .dw 0x0006

keys::
  .dw Key_A
  .db left
  .db idle
  .dw #_hero_sp_3

  .dw Key_D
  .db right
  .db idle
  .dw #_hero_sp_2

  .dw Key_W
  .db idle
  .db up
  .dw #_hero_sp_1

  .dw Key_S
  .db idle
  .db down
  .dw #_hero_sp_0

  .dw 0

DefineObjEntity  key_data, 0x44, 0x44, 0x44, 0x68, 0x68, 0x68, 0x02, 0x08, _key_sp, 0x18
                                                          ;; bit 7-Animed (bit 7 == 1)
                                                          ;; bit 6-Enemy  (bit 6 == 1)
                                                          ;; bit 5-Pick   (bit 5 == 1)
                                                          ;; bit 4-Draw (bit 4 == 1)
                                                          ;; bit 3-Draw (bit 3 == 1)
                                                          ;; 
                                                          ;


k_max_num_ent = 10                  ;; Initial number of entities
k_entity_size = 15                  ;; Entity size 

;; Vector of Walls
;; bit 7 si animado
;; (bit 7 == 1) bit 6 si es enemigo
;; (bit 6 == 0) bit 5 si tiene llave
entity_vector:
  DefineNEntities entity_vector, k_entity_size
  DefineEntity hero_data, 0x04, 0x04, 0x04, 0x40, 0x40, 0x40, 0x04, 0x10, _hero_sp_0, 0x9E, 0x00, 0x00, ent_moveKeyboard
  DefineEntity enemy_data, 0x04, 0x04, 0x04, 0x20, 0x20, 0x20, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data1, 0x30, 0x30, 0x30, 0x20, 0x20, 0x20, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data2, 0x4A, 0x4A, 0x4A, 0x30, 0x30, 0x30, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data3, 0x40, 0x40, 0x40, 0x20, 0x20, 0x20, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data4, 0x04, 0x04, 0x04, 0x60, 0x60, 0x60, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data5, 0x30, 0x30, 0x30, 0x10, 0x10, 0x10, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data6, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move
  DefineEntity enemy_data7, 0x30, 0x30, 0x30, 0x40, 0x40, 0x40, 0x04, 0x10, _definity_enemy_sp_00, 0xD8, 0x00, 0x00, pattern_move

;; Counter of entities active
m_num_ent: .db 00

;; First position of the vector of entities
m_next_entity: .dw entity_vector

;;  Constants moves
right_columns: .db #+1              ;;  Move in columns
left_columns: .db #-1               ;;  Move in colums
up_rows: .db #-2                    ;;  Move in rows
down_rows: .db #+2                  ;;  Move in rows

;;===============================================================
;;===============================================================
;; PUBLIC FUNCTIONS
;;===============================================================
;;===============================================================


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DRAW AN ENTITY
;; DESTROYED REGISTERS: AF, BC, DE, HL
;; INPUT: IX -> Pointer to Entity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_draw:
  jp  ren_drawEntity
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; EREASE AN ENTITY
;; DESTROYED REGISTERS: AF, BC, DE, HL, AF'
;; INPUT: IX -> Pointer to Entity
;; No funciona del todo ya que no borra los sprites sino que coge el fondo del propio sprite para pintar de fondo.
;; Si se añade en A el color de fondo no funciona bien el gestor de entidades ya que borra a los enemigos.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_clear:
 	ld		a,	#00											;; Load in A background color
	call  ent_draw										;; Draw entity
	ret
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UPDATE AN ENTITY
;; DESTROYED REGISTERS: HL, A
;; INPUT: IX -> Pointer to Entity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_update:
	ld		h, e_up_h(ix)								;; H = High Bit of direction of memory of update function
	ld		l, e_up_l(ix)								;; L = Low Bit of direction of memory of update function
	jp		(hl)												;; Jump of update function

;;===============================================================
;;===============================================================
;; PRIVATE FUNCTIONS
;;===============================================================
;;===============================================================
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CLEAN THE VECTOR
;; DESTROYED REGISTERS: A, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vector_clean::
  ld a,#0
  ld (m_num_ent),a
  ld hl, #entity_vector
  ld (m_next_entity), hl
  ret
;;Revisar esta rutina
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CREATE AN ENTITY
;; DESTROYED REGISTERS: AF, HL, BC
;; OUTPUT: HL -> Pointer to Entity 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_new:
	ld 		a,	(m_num_ent)							;; A = counter entities to modify
	inc		a														;; A ++ 
	ld		(m_num_ent),	a
	ld		hl, (m_next_entity)					;; HL = Pointer to beginning of the vector
	ld		bc, #k_entity_size					;; BC = Total bytes of each vector entity
	add		hl, bc											;; HL = Pointer to next vector
	ld		(m_next_entity), hl					;; m_next_entity = Pointer to next vector
	ld		bc, #-k_entity_size					;; BC = pointer the vector to the entity before the created one
	add		hl, bc
	ret

;;Revisar rutina
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COPY AN ENTITY
;; DESTROYED REGISTERS:	HL, BC, DE
;; INPUT:
;;  HL -> Entidad Origen
;;  DE -> Entidad Destino
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_copy:
  ld		bc, #k_entity_size					;; BC = Size (in Bytes) of Entity
  ldir 															;; Copy in HL as many bytes in DE as the value of the counter BC
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA TODAS LAS ENTIDADES
;; INPUT:	HL	->	Pointer method to execute
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_doForAll::
  ld a, (m_num_ent)                 ;;  A = Number of entitys            
  ld ix, #entity_vector
  ld (metodo), hl
  or a
  jr nz,buc
        ret
  
  buc:
  push af                           ;;  Save in stack number of entitys
  metodo = . + 1                    ;;  Method that will be executed
  call ent_draw                     ;;  Execute the method
  call check_draw
  pop af                            ;;  Restaure number of entitys
  ld bc, #k_entity_size
  add ix, bc 												;;  IX = point to the following entity
  dec a                             ;;  Number of entitys - 1               
  jr nz, buc
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COMPRUEBA COLISIONES CON LOS ENEMIGOS
;; INPUT: HL  ->  Pointer method to execute
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ent_doForAllY::
;  ld a, (m_num_ent)
;  ld iy, #entity_vector
;  or a
;  jr nz,before
;        ld a,#0                     ;; If there isn't entitys, do nothing
;        ret
;  
;  before:
;  ld ix, #entity_vector             ;; Load first position (hero)
;  ld bc, #k_entity_size
;  add iy,bc
;  dec a
;  or a
;  jr nz,bucY
;    ld a, #0
;    ret
;  bucY:
;  push af                           ;; Save in stack A = number of entitys
;  call checkCollision_enemy
;  or a
;  jr nz, dead                       ;; Jump if the hero had dead
;        ld bc, #k_entity_size
;        add iy, bc                  ;; IY = point to the following entity
;        pop af
;        dec a
;        jr nz, bucY
;              ld a,#0
;              ret
;  
;  dead:
;  pop af
;  ld a,#1
;  ret


ent_doForAllY::
  ld a, (m_num_ent)
  ld de, #entity_vector
  or a
  jr nz,before
        ld a,#0                     ;; If there isn't entitys, do nothing
        ret
  
  before:
  ld ix, #entity_vector             ;; Load first position (hero)
  ld bc, #k_entity_size
  ex  de, hl
  add hl,bc
  ex  de, hl
  dec a
  or a
  jr nz,bucY
    ld a, #0
    ret
  bucY:
  push af   
  push de                        ;; Save in stack A = number of entitys
  call checkCollision_enemy
  pop de
  or a
  jr nz, dead                       ;; Jump if the hero had dead
        ld bc, #k_entity_size
        ex  de, hl
        add hl,bc
        ex  de, hl
        pop af
        dec a
        jr nz, bucY
              ld a,#0
              ret
  
  dead:
  pop af
  ld a,#1
  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVE AN ENTITY BY KEYBOARD
;; DESTROYED REGISTERS: AF, BC, DE, HL 
;; INPUT: IX -> Pointer to Entity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveKeyboard:
  call  cpct_scanKeyboard_asm 

  ld    iy,  #keys
  ld    b, #4
  check_next_key:

    ld    l, key_l(iy)
    ld    h, key_h(iy)

    call  cpct_isKeyPressed_asm
    jr    z, no_pressed 

      ld    l, sprite_l(iy)       ;;  Load in HL sprite hero
      ld    h, sprite_h(iy) 
      ld    de_sp_l(ix),  l       ;;  Save in entity hero the sprite in HL
      ld    de_sp_h(ix),  h

      ld    a, direction_x(iy);(left_columns)
      add   e_vx(ix)
      ld    e_vx(ix), a           ;; update vx

      ld    a, direction_y(iy)
      add   e_vy(ix)
      ld    e_vy(ix), a           ;; update vy

      ld    a, e_ch(ix)
      set   #4, a
      set   #3, a
      ld    e_ch(ix), a
      dec b
      jr z,check_next_key

  no_pressed:
    ld    bc, (option_size)
    add   iy, bc
    ld    a, key_h(iy)
    or    a
    jr    nz, check_next_key
    
    
    call collision_map

    ld  a, (axis)
    inc   a
    ld  (axis), a 

    ;; check_axisY
    call collision_map
    
    ld  a, (axis)
    ld    a,  #0
    ld  (axis), a 
    ret
    
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVE AN ENTITY
;; DESTROYED REGISTERS: A, D
;; INPUT: IX -> Pointer to Entity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move::
  ld  a, (axis)
  cp  #0
  jr   nz, axisY

    ;;check Axis X


    ld    a, de_x0(ix)                ;; A = e_x
    add   e_vx(ix)                    ;; A = A + e_vx, (e_x + e_vx)
    ld    de_x0(ix), a                ;; Update, e_x = A

   ; ld    a, de_y0(ix)                ;; A = e_y
   ; add   e_vy(ix)                    ;; A = A + e_vy, (e_y + e_vy)
   ; ld    de_y0(ix), a                ;; Update, e_y = A
    ;call   check_collision_axisX
    ret

  axisY:
    ;;check Axis Y
    

    ld    a, de_y0(ix)                ;; A = e_y
    add   e_vy(ix)                    ;; A = A + e_vy, (e_y + e_vy)
    ld    de_y0(ix), a                ;; Update, e_y = A

    ; ld    a, de_x0(ix)                ;; A = e_x
    ;add   e_vx(ix)                    ;; A = A + e_vx, (e_x + e_vx)
    ;ld    de_x0(ix), a                ;; Update, e_x = A

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INCREASE THE DEATHS COUNTER
;; DESTROYED REGISTERS: IY, HL, DE, A, B, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
dead_hero::

    call counter_number_of_deads
  
  restauro::
  ld ix, (levelPos)               ;; Cargamos el data del nivel para poder acceder a la pos del hero por defecto
  ld a, m_hx(ix)
  ld b, m_hy(ix)
  ld  ix, #entity_vector ;+ 2
  ld de_x0(ix),a
  ld de_y0(ix),b
  ;ld de_x1(ix),a
  ;ld de_y1(ix),b
  ;ld de_x2(ix),a
  ;ld de_y2(ix),b
  ld  a, e_ch(ix)
  res #5, a
  ;set #7, a
  set #4, a
  set #3, a
  ld e_ch(ix), a 
  ;push   ix
  ;ld    ix, #key_data
  ;call  ren_drawEntity
  ;call map_switchBuffers
  ;ld    ix, #key_data
  ;call  ren_drawEntity 
  ;call map_switchBuffers
  ;pop ix

  call  redraw_the_key
  ret