;//-----------------------------LICENSE NOTICE------------------------------------
;//  This file is part of Project AcReturns
;//  Copyright (C) 2018 AcReturns
;//
;//  This program is free software: you can redistribute it and/or modify
;//  it under the terms of the GNU General Public License as published by
;//  the Free Software Foundation, either version 3 of the License, or
;//  (at your option) any later version.
;//
;//  This program is distributed in the hope that it will be useful,
;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;//  GNU General Public License for more details.
;//
;//  You should have received a copy of the GNU General Public License
;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;//-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "map.h.s"
.include "entity.h.s"

;.globl _tileset
;.globl _g_level1
.globl _tile64set
  .globl camino
;.globl _g_level3

K_maps_size = 17
DefineDrawableEntity final_score_first_digit_data, 0x28, 0x28, 0x28, 0x4C, 0x4C, 0x4C, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity final_score_second_digit_data, 0x2C, 0x2C, 0x2C, 0x4C, 0x4C, 0x4C, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity final_score_third_digit_data, 0x30, 0x30, 0x30, 0x4C, 0x4C, 0x4C, 0x04, 0x08 , _numeros_sp_00

GroupOfMaps:
;;DefineMap _name,        _kx,  _ky,  _hx,  _hy, _n_e, _ex1, _ey1, _ex2, _ey2, _ex3, _ey3, _ex4, _ey4, _ex5, _ey5, _map
  DefineMap level1_data, 0x28, 0x50, 0x36, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, _level1_pack_end
  DefineMap level2_data, 0x28, 0x50, 0x36, 0x28, 0x01, 0x30, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, _level1_pack_end
  DefineMap level3_data, 0x30, 0x40, 0x0E, 0x14, 0x01, 0x40, 0x5C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, _level3_pack_end
  DefineMap level4_data, 0x2E, 0x10, 0x3E, 0x54, 0x04, 0x30, 0x66, 0x30, 0x30, 0x40, 0x10, 0x10, 0x30, 0x00, 0x00, _level4_pack_end
  DefineMap level5_data, 0x26, 0x20, 0x04, 0x40, 0x03, 0x3A, 0x18, 0x14, 0x60, 0x36, 0x60, 0x00, 0x00, 0x00, 0x00, _level5_pack_end
  DefineMap level6_data, 0x32, 0x2C, 0x04, 0x6C, 0x03, 0x10, 0x3C, 0x16, 0x08, 0x38, 0x60, 0x00, 0x00, 0x00, 0x00, _level6_pack_end
  DefineMap level7_data, 0x42, 0x70, 0x06, 0x10, 0x04, 0x30, 0x62, 0x10, 0x5E, 0x06, 0x2C, 0x26, 0x24, 0x00, 0x00, _level7_pack_end
  DefineMap level8_data, 0x06, 0x34, 0x42, 0x10, 0x05, 0x02, 0x18, 0x04, 0x48, 0x24, 0x30, 0x2C, 0x14, 0x40, 0x6C, _level8_pack_end
  DefineMap level9_data, 0x28, 0x38, 0x04, 0x10, 0x04, 0x04, 0x6C, 0x10, 0x2C, 0x3A, 0x2C, 0x48, 0x6C, 0x00, 0x00, _level9_pack_end

levelPos: .dw GroupOfMaps
levelMap: .dw _level1_pack_end
level: .db 00

;level: .dw _level3_pack_end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; RETURN VALUES OF A MAP
;; INPUT: A -> LEVEL TO LOAD
;; DESTROYED REGISTERS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_level::
  push af

  ld   hl, #_hud_pack_end
  call decompress_maps_hud    ;; Decompress the map
  ;call redraw_hud

  pop af
  ld (level),a
  push af
  ld  a,  #180
  ld  (camino), a
  pop af
  ;ld hl, #_level1_pack_end
  ld ix, #level1_data
  ld h, m_map_h(ix)
  ld l, m_map_l(ix)
  or a
  jr z, continue            ;; if the level is 1

  load_loop:
    ld  bc, #K_maps_size    ;; Advance the map data
    add ix, bc
    ld h, m_map_h(ix)
    ld l, m_map_l(ix)
    dec a
    jr nz, load_loop

continue:
  ld (levelMap), hl         ;; Save the value of the level
  ld (levelPos), ix

  call decompress_maps    ;; Decompress the map
  call vector_clean       ;; Libera la memoria del vector

  call  redraw_map

  ld ix, (levelPos)
  ld b, m_hx(ix)
  ld c, m_hy(ix)
  
  ld iy, #hero_data
  ld de_x0(iy), b
  ld de_y0(iy), c
  ld de_x1(iy), b
  ld de_y1(iy), c
  ld de_x2(iy), b
  ld de_y2(iy), c

  call ent_new            ;; Amplia el numero de entidades
  ex de,hl                ;; Necesitamos en DE el puntero donde vamos a copiar
  ld hl, #hero_data       ;; El puntero a la entidad a copiar
  call ent_copy           ;; Copiamos los valores en la posicion

  ;; Load the key
  ld  iy, #key_data
  ld  b, m_kx(ix)
  ld  c, m_ky(ix)

  ld de_x0(iy), b
  ld de_y0(iy), c
  ld de_x1(iy), b
  ld de_y1(iy), c
  ld de_x2(iy), b
  ld de_y2(iy), c
  ;; Load the enemys

  ld  a, m_n_e(ix)
  or a
  jr z, end               ;; If we dont have enemys to load

  push af
  ld de, #4
  add ix, de
  loop:
    inc ix
    ld b, (ix)           ;; Load the value of the enemys saved in the map
    inc ix
    ld c, (ix)
    push ix

    ld iy, #enemy_data
    ld de_x0(iy), b
    ld de_y0(iy), c
    ld de_x1(iy), b
    ld de_y1(iy), c
    ld de_x2(iy), b
    ld de_y2(iy), c

    call ent_new            ;; Amplia el numero de entidades
    ex de,hl                ;; Necesitamos en DE el puntero donde vamos a copiar
    ld hl, #enemy_data      ;; El puntero a la entidad a copiar
    call ent_copy           ;; Copiamos los valores en la posicion

    pop ix
    pop af
    dec a
    jr z, end               ;; If we dont have more enemys to load
    push af
    jr loop                 ;; if we have more enemys to load

end:

  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DECOMPRESS MAPS
;; INPUT: HL -> LAST POSITION OF THE MAP
;; DESTROYED REGISTERS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
decompress_maps::
  ld de, #decompress_buffer_end
  call cpct_zx7b_decrunch_s_asm
  ret
decompress_maps_hud::
  ld de, #decompress_buffer_hud_end
  call cpct_zx7b_decrunch_s_asm
  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LOAD THE NEXT LEVEL
;; DESTROYED REGISTERS: HL, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
next_level::
  ld a,(level)
  call load_level
  ld a,(level)
  inc a
  ld (level), a

  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CREA EL MAPA
;; DESTROYED REGISTERS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
map_inicialize::
  ;ld hl, (levelMap)
  
  ld    hl,  #_tile64set
  call  cpct_etm_setTileset2x4_asm
  ld  hl, #0x8000
  ld  de, #0x8001
  ld  (hl), #00
  ld  bc, #0x4000
  ldir

  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Carga el final
;; DESTROYED REGISTERS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_theEnd::

  ld  hl, #0x8000
  ld  de, #0x8001
  ld  (hl), #00
  ld  bc, #0x8000
  ldir

  ld    hl, #_final_pack_end
  call decompress_maps_hud
  call redraw_map

  ld    ix, #score_first_digit_data
  ld    h, de_sp_h(ix)
  ld    l, de_sp_l(ix)
  ld    ix, #final_score_first_digit_data
  ld    de_sp_h(ix), h
  ld    de_sp_l(ix), l
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #score_second_digit_data
  ld    h, de_sp_h(ix)
  ld    l, de_sp_l(ix)
  ld    ix, #final_score_second_digit_data
  ld    de_sp_h(ix), h
  ld    de_sp_l(ix), l
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers

  ld    ix, #score_third_digit_data
  ld    h, de_sp_h(ix)
  ld    l, de_sp_l(ix)
  ld    ix, #final_score_third_digit_data
  ld    de_sp_h(ix), h
  ld    de_sp_l(ix), l
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers
  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MAPA
;; DESTROYED REGISTERS: AF, BC, DE, HL AF, BC, DE, HL
;; INPUT:	DE	->	Video memory location where to draw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
map_draw::
  ld    hl, #decompress_buffer             ;; Pointer to the start of the tilemap
  push  hl                          
  push  de                          ;; Pointer to upper left corner of the tilemap in video memory. 
  ld    bc, #0000                   ;; First position of screen B = Y , C = x (y = tile_coordinate ; x = tile_coordinate)
  ld    de, #0x3228                 ;; E = tile width  D = tile height (Defined in src/level/map1.h) 
  ld    a, #40                      ;; Width in tiles of a complete row of the tilemap
  call  cpct_etm_drawTileBox2x4_asm 
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MAPA EN AMBOS BUFFERS
;; DESTROYED REGISTERS: AF, BC, DE, HL AF, BC, DE, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
redraw_map:
  call getBackBuffer
  ld  d,  a
  ld  e,  #0
  call map_draw
  call getFrontBuffer
  ld  d,  a
  ld  e,  #0
  call map_draw
  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MAPA
;; DESTROYED REGISTERS: AF, BC, DE, HL AF, BC, DE, HL
;; INPUT: DE  ->  Video memory location where to draw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
hud_draw::
  ld    hl, #decompress_hud              ;; Pointer to the start of the tilemap
  push  hl                          
  push  de                          ;; Pointer to upper left corner of the tilemap in video memory. 
  ld    bc, #0000                   ;; First position of screen B = Y , C = x (y = tile_coordinate ; x = tile_coordinate)
  ld    de, #0x1128                 ;; E = tile width  D = tile height (Defined in src/level/map1.h) 
  ld    a, #40                      ;; Width in tiles of a complete row of the tilemap
  call  cpct_etm_drawTileBox2x4_asm 
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MAPA EN AMBOS BUFFERS
;; DESTROYED REGISTERS: AF, BC, DE, HL AF, BC, DE, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
redraw_hud:
  call getBackBuffer
  ld  d,  a
  ld  e,  #0
  push de
  ld  bc, #0x8400
  call cpct_getScreenPtr_asm
  pop   de
  ex    de, hl
  add   hl, de
  call hud_draw
  call getFrontBuffer
  ld  d,  a
  ld  e,  #0
  push de
  ld  bc, #0x8400
  call cpct_getScreenPtr_asm
  pop   de
  ex    de, hl
  add   hl, de
  call hud_draw

  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA LA LLAVE
;; DESTROYED REGISTERS: HL, BC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
redraw_the_key:
  ld    ix, #key_data
  ld    hl, #decompress_buffer
  ld    bc, #00
  call  conversor_x_y_in_tiles_and_check_collision
  ld    (hl), #32
  ld    bc, #0x0028
  add   hl, bc
  ld    (hl), #48
  call  ren_drawEntity
  call  map_switchBuffers

  call  ren_drawEntity
  call  map_switchBuffers
  ret