;//-----------------------------LICENSE NOTICE------------------------------------
;//  This file is part of Project AcReturns
;//  Copyright (C) 2018 AcReturns
;//
;//  This program is free software: you can redistribute it and/or modify
;//  it under the terms of the GNU General Public License as published by
;//  the Free Software Foundation, either version 3 of the License, or
;//  (at your option) any later version.
;//
;//  This program is distributed in the hope that it will be useful,
;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;//  GNU General Public License for more details.
;//
;//  You should have received a copy of the GNU General Public License
;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;//-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "menu.h.s"
.include "keyboard/keyboard.h.s"
.include "entity.h.s"
.include "map.h.s"
.include "counters.h.s"

.globl getFrontBuffer
;.globl points
.globl restart_dead
.globl run
.globl negative_size_digit
;.globl seconds_timer
;.globl counter_deaths

;;  String finish the level
DefineDrawableEntity menu_data, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x08 , _numeros_sp_00
  DefineDrawableEntity menu_data2, 0x32, 0x32, 0x32, 0x4C, 0x4C, 0x4C, 0x04, 0x10 , _numeros_sp_01

vector_manual:
  DefineDrawableEntity hero_data_manual_up, 0x38, 0x38, 0x38, 0x20, 0x20, 0x20, 0x04, 0x10 , _hero_sp_1
  DefineDrawableEntity hero_data_manual_down, 0x42, 0x42, 0x42, 0x30, 0x30, 0x30, 0x04, 0x10 , _hero_sp_0
  DefineDrawableEntity hero_data_manual_left, 0x38, 0x38, 0x38, 0x40, 0x40, 0x40, 0x04, 0x10 , _hero_sp_3
  DefineDrawableEntity hero_data_manual_right, 0x42, 0x42, 0x42, 0x50, 0x50, 0x50, 0x04, 0x10 , _hero_sp_2
  DefineDrawableEntity enemy_data_manual, 0x3A, 0x3A, 0x3A, 0xA0, 0xA0, 0xA0, 0x04, 0x10 , _definity_enemy_sp_02

DefineDrawableEntity level_first_digit_data, 0x30, 0x30, 0x30, 0x20, 0x20, 0x20, 0x04, 0x08 , _numeros_sp_00

DefineDrawableEntity level_second_digit_data, 0x34, 0x34, 0x34, 0x20, 0x20, 0x20, 0x04, 0x08 , _numeros_sp_01


counter_redefine_key: .db 00
option_size: .dw 0x0006  


;jump_direction:


option_size_menu: .dw 0x0004

;; esta en el entity.h.s
key_l            = 0
key_h            = 1
jump_direction_l = 2  
jump_direction_h = 3



;play_the_game =  0x00C9 ;;ret

keys_menu:
  .dw Key_1
  .dw play_the_game

  .dw Key_2
  .dw redefine_keys

  .dw Key_3
  .dw load_manual

  .dw Key_4
  .dw load_credits

  .dw 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; EREASE ALL THE SCREEN
;; DESTROYED REGISTERS: HL,DE 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
world_clear:
  ld  hl, #0x8000                   ;; Inicio
  ld  de, #0x8001                   ;; Destino
  ld  (hl), #00                     ;; Cargamos al inicio 0
  ld  bc, #0x8000                   ;; Contador
  ldir                              ;; Copiamos en DE el valor de HL tantas veces como BC
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DRAW THE MAIN MENU
;; DESTROYED REGISTERS: DE, HL, BC, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_menu::
  call world_clear                  ;; Clear screen double buffer
  ;call draw_options                 ;; Draw in screen the options
  ld    hl, #_mainMenu_pack_end
  call  decompress_maps_hud

  call  redraw_map
  ;; 

  loop:



  call  cpct_scanKeyboard_asm 

  ld    iy,  #keys_menu
  check_next_key2:

    ld    l, key_l(iy)
    ld    h, key_h(iy)


    call  cpct_isKeyPressed_asm
    jr    z, no_pressed 

      ld    c,  jump_direction_l(iy)
      ld    b,  jump_direction_h(iy)

      ld (metodo), bc                        ;;  Save in stack number of entitys
      metodo = . + 1                    ;;  Method that will be executed
      jp ent_draw                     ;;  Execute the method

      
      ;jr  play_the_game2

  no_pressed:
    ld    bc, (option_size_menu)
    add   iy, bc
    ld    a, key_h(iy)
    or    a
    jr    nz, check_next_key2

      jr  loop

   play_the_game:
   call inicialize_counters
   ld   a, #0
   ld   (level),a
   call load_endScreen
   call load_level

   ret

   load_credits:
   ld     hl, #_credits_pack_end
   call   decompress_maps_hud

   call   redraw_map
   jr wait_press

   load_manual:
   ld     hl, #_instructions_pack_end
   call   decompress_maps_hud

   call   redraw_map
   ld     a, #5
   ld    ix, #vector_manual
   loop_manual:
    push af
    call  ren_drawEntity
    call  map_switchBuffers
    call  ren_drawEntity
    call  map_switchBuffers
    ld     bc, #10
    add   ix, bc
    pop af
    dec a
    jr nz,loop_manual

    next_page:
    call  cpct_scanKeyboard_asm    
    ld    hl, #Key_N
    call  cpct_isKeyPressed_asm       
    jr    z, next_page              ;; If (A == 0) then comprueba_c
    
    ld     hl, #_instructions2_pack_end
    call   decompress_maps_hud

    call   redraw_map

   wait_press:
   call  cpct_scanKeyboard_asm    
   ld    hl, #Key_M
   call  cpct_isKeyPressed_asm       
   jr    z, wait_press              ;; If (A == 0) then comprueba_c
   ;call 
   jp load_menu
   ;ret

load_second_digit:
  ld    ix, #level_second_digit_data
  ld    l, de_sp_l(ix)
  ld    h, de_sp_h(ix)
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DRAW THE END SCREEN OF THE LEVEL
;; DESTROYED REGISTERS: HL, IY, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_endScreen::
  
  ld  a, (level) 
  inc a                       ;; If the next level dosent exist
  ld b, #K_num_maps + 1
  cp b                        ;; If 0, then is the final map
  jr nz, continue_end

  call load_theEnd            ;; Load the final screen

  loop_end:
  call  cpct_scanKeyboard_asm     
  ld    hl, #Key_M                
  call  cpct_isKeyPressed_asm       
  jr    z, loop_end              ;; If (A == 0) then comprueba_c
    
  call  #run 
  ret

  continue_end:
  ;continue_level:
  ;; Clean the screen
  ld  hl, #0x8000
  ld  de, #0x8001
  ld  (hl), #00
  ld  bc, #0x8000
  ldir
  ld    hl, #_nextLevel_pack_end
  call  decompress_maps_hud

  call  redraw_map

  ld    ix, #level_first_digit_data
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers
  ld    l, de_sp_l(ix)
  ld    h, de_sp_h(ix)

  ;; Load the second digit
  ld    ix, #level_second_digit_data
  ld    a, (level)
  ld    bc, (size_digit)
  ld    hl, #_numeros_sp_00
  loop_endScreen:
    add   hl, bc
    dec   a
    jp    p, loop_endScreen

  ld    de_sp_l(ix), l
  ld    de_sp_h(ix), h 

  
  call  ren_drawEntity
  call  map_switchBuffers
  call  ren_drawEntity
  call  map_switchBuffers
  ld    l, de_sp_l(ix)
  ld    h, de_sp_h(ix)

  comprueba_c:

  call  cpct_scanKeyboard_asm      
  ld    hl, #Key_C                
  call  cpct_isKeyPressed_asm       
  jr    z, comprueba_c             ;; If (A == 0) then loop_restart

  ;ld iy, #endGame                
  ;call word_clear
  ;ld  hl,  #0x3036               
  ;ld  (seconds_timer),  hl
  call  next_level
  call  #restart_dead               ;; Restauramos contador y cargamos nivel

  ret



;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;
redefine_keys::
  
  call  world_clear 
  ld    hl, #_redefinekeysLEFT_pack_end

  ld    iy, #keys
  next_definition_key:

    ld    a, (counter_redefine_key)
    cp    #1
    jr    z, redefine_right
      cp    #2
      jr    z, redefine_up
        cp    #3
        jr    z, redefine_down
          jr    draw_next_redefine_key

    redefine_right:
      ld    hl, #_redefinekeysRIGHT_pack_end
     
      jr    draw_next_redefine_key
    redefine_up:
      ld    hl, #_redefinekeysUP_pack_end
     
      jr    draw_next_redefine_key

    redefine_down:
      ld    hl, #_redefinekeysDOWN_pack_end
      
    
    draw_next_redefine_key:


    call  decompress_maps_hud
    call  redraw_map


    
  check_next_key:
  
 ; call  show_redefine_key
  ld    ix, #menu_data2
  ld    b, sprite_l(iy)

  ld    de_sp_l(ix), b
  ld    b, sprite_h(iy)

  ld    de_sp_h(ix), b


      call  ren_drawEntity
      call  map_switchBuffers
      call  ren_drawEntity
      call  map_switchBuffers

      
    ld    a, #0x20
    call loop_wait


  ;;bucle hasta que pulse una tecla
    
      waiting_key:
        call cpct_scanKeyboard_asm  
       
        call cpct_isAnyKeyPressed_asm

        
        jr  z, waiting_key
      
      ;

    waiting:
    ld  hl, #_cpct_keyboardStatusBuffer ;; [3] HL Points to the start of the keyboard status buffer
    ld   b, #10;#10           ;; [2] We are going to do 9 AND operations against the first byte of the buffer
    ld   a, (hl)         ;; [2] A = First byte from keyboardStatusBuffer
    dec   hl
    and_loop:
      inc  hl              ;; [2] HL points to the next byte from the KeyboardStatusBuffer
      ;and (hl)             ;; [2] A = A & NextByte (The byte pointed by HL)
      ld   a, (hl)  

      inc   a
      jr   nz, key_press
        dec   a
        
        djnz and_loop        ;; [3/4] Repeat until all 9 bytes have been ANDed (Then B = 0)

        ;inc   a              ;; [1] A holds the result of ANDing the 10 bytes. If no key is pressed, all bits should
                              ;; ... be 1, so A=0xFF. If we add 1, A=0, we return FALSE (no key is pressed).
                              ;; ... If any key is pressed, some bit will be 0, so A != 0xFF, which means A+1 != 0, and 
                              ;; ... we will be returning TRUE (A > 0)
        ;ld    l, a           ;; [1] L = A (Set return value for C calls in L)
       
        jr  check_next_key
        ;et                  ;; [3] Return   

      key_press:
     
      dec   a
      ld    c, #0xFF
      xor   c
      ld    h, a
     


    ;is_the_key:
    ;;key in hl
      ld    a, #10;#10;#9
      sub   b 
      ld    l, a
     

      
           ;sprite_l    = 4
       ; sprite_h
 
      ;ld    ix, #menu_data2

      ld    a, (counter_redefine_key)
      inc   a
      ld    (counter_redefine_key), a
     

      ld    key_l(iy), l
      ld    key_h(iy), h

      ld    bc, (option_size)
      add   iy, bc
      ld    a, key_h(iy)
      or    a
      jp    nz, next_definition_key

      ;pop hl
      ld    a, #0
      ld    (counter_redefine_key), a
        jp load_menu
        ;jp loop





  ;a= num bite donde se presiona la tecla, parte derecha la h

  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DRAW A MENu
;; DESTROYED REGISTERS: DE, HL, BC, A
;; Espera en iy un string, y en ix la entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
draw_menu:
  ld    ix, #menu_data
  call  ren_drawEntity

  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DRAW AN ENTITY
;; DESTROYED REGISTERS: AF, BC, DE, HL
;; INPUT: IX -> Pointer to Entity
;; INPUT: BC -> First position of video memory
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
clean_keyboardStatusBuffer:

  ld  hl, #_cpct_keyboardStatusBuffer ;; [3] HL Points to the start of the keyboard status buffer
  ld   b, #9           ;; [2] We are going to do 9 AND operations against the first byte of the buffer
  ld   a, (hl)         ;; [2] A = First byte from keyboardStatusBuffer

  and_loop2:
    inc  hl              ;; [2] HL points to the next byte from the KeyboardStatusBuffer
    ld  (hl), #0xFF             ;; [2] A = A & NextByte (The byte pointed by HL)
    
    
    djnz and_loop2        ;; [3/4] Repeat until all 9 bytes have been ANDed (Then B = 0)

  

  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LOAD A PAUSE MENU
;; DESTROYED REGISTERS: HL, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_pause::
;; Mira si escape es pulsada
  call  cpct_scanKeyboard_asm
  ld    hl, #Key_Esc
  call  cpct_isKeyPressed_asm       
  jr    z, end              ;; If (Esc == 0) then comprueba_c

  ;; Descomprime el menu
  ld    hl, #_levelMenu_pack_end
  ld    de, #decompress_buffer_end - #0x0190
  call cpct_zx7b_decrunch_s_asm
  ;call  decompress_maps    ;; Decompress the map

  call  redraw_map        ;; Draw the miniMenu

  loop_pause:
    call  cpct_scanKeyboard_asm      
    ld    hl, #Key_2                
    call  cpct_isKeyPressed_asm       
    jp    nz, #run 


    call  cpct_scanKeyboard_asm
    ld    hl, #Key_1
    call  cpct_isKeyPressed_asm       
    jr    z, loop_pause              ;; If (Esc == 0) then comprueba_c

    ld  ix, (levelPos)
    ld  h, m_map_h(ix)
    ld  l, m_map_l(ix)
    call  decompress_maps
    ;call #run
    call  redraw_map        ;; Draw the miniMenu

    ld    ix, #entity_vector
    call  ren_drawEntity

    call map_switchBuffers
    call  ren_drawEntity


    call map_switchBuffers

    ld    a, e_ch(ix)
    bit   #5, a
    jr    z,  no_have_key

      ld    ix, #key_data
      ld    hl, #decompress_buffer
      ld    bc, #00
      call  conversor_x_y_in_tiles_and_check_collision
      ld    (hl), #16
      ld    bc, #0x0028
      add   hl, bc
      ld    (hl), #16
      call  ren_eraseEntity
      call  map_switchBuffers

      call  ren_eraseEntity
      call  map_switchBuffers


    no_have_key:
      

end:
  ret

loop_wait:

  halt
  dec a
  jr  nz, loop_wait
  ret